]> Sergey Matveev's repositories - zsh-autoenv.git/blob - autoenv.zsh
Fix (auto)unstashing when being sourced from a subdir (#79)
[zsh-autoenv.git] / autoenv.zsh
1 # Initially based on
2 # https://github.com/joshuaclayton/dotfiles/blob/master/zsh_profile.d/autoenv.zsh
3
4 # File to store confirmed authentication into.
5 # This handles the deprecated, old location(s).
6 if [[ -z $AUTOENV_AUTH_FILE ]]; then
7   if [[ -n $AUTOENV_ENV_FILENAME ]]; then
8     echo "zsh-autoenv: using deprecated setting for AUTOENV_AUTH_FILE from AUTOENV_ENV_FILENAME." >&2
9     echo "Please set AUTOENV_AUTH_FILE instead." >&2
10     AUTOENV_AUTH_FILE=$AUTOENV_ENV_FILENAME
11   else
12     if [[ -n $XDG_DATA_HOME ]]; then
13       AUTOENV_AUTH_FILE=$XDG_DATA_HOME/autoenv_auth
14     else
15       AUTOENV_AUTH_FILE=~/.local/share/autoenv_auth
16     fi
17     if [[ -f ~/.env_auth ]]; then
18       echo "zsh-autoenv: using deprecated location for AUTOENV_AUTH_FILE." >&2
19       echo "Please move it: mv ~/.env_auth ${(D)AUTOENV_AUTH_FILE}" >&2
20       AUTOENV_AUTH_FILE=~/.env_auth
21     fi
22   fi
23 fi
24
25 # Name of the file to look for when entering directories.
26 : ${AUTOENV_FILE_ENTER:=.autoenv.zsh}
27
28 # Name of the file to look for when leaving directories.
29 # Requires AUTOENV_HANDLE_LEAVE=1.
30 : ${AUTOENV_FILE_LEAVE:=.autoenv_leave.zsh}
31
32 # Look for zsh-autoenv "enter" files in parent dirs?
33 : ${AUTOENV_LOOK_UPWARDS:=1}
34
35 # Handle leave events when changing away from a subtree, where an "enter"
36 # event was handled?
37 : ${AUTOENV_HANDLE_LEAVE:=1}
38
39 # Enable debugging. Multiple levels are supported (max 2).
40 : ${AUTOENV_DEBUG:=0}
41
42 # (Temporarily) disable zsh-autoenv. This gets looked at in the chpwd handler.
43 : ${AUTOENV_DISABLED:=0}
44
45 # Public helper functions, which can be used from your .autoenv.zsh files:
46
47 # Source the next .autoenv.zsh file from parent directories.
48 # This is useful if you want to use a base .autoenv.zsh file for a directory
49 # subtree.
50 autoenv_source_parent() {
51   local look_until=${1:-/}
52   local parent_env_file=$(_autoenv_get_file_upwards \
53     ${autoenv_env_file:h} ${AUTOENV_FILE_ENTER} $look_until)
54
55   if [[ -n $parent_env_file ]] \
56     && _autoenv_check_authorized_env_file $parent_env_file; then
57     _autoenv_debug "Calling autoenv_source_parent: parent_env_file:$parent_env_file"
58     _autoenv_source $parent_env_file enter
59   fi
60 }
61
62 # Internal functions. {{{
63 # Internal: stack of loaded env files (i.e. entered directories). {{{
64 typeset -g -a _autoenv_stack_entered
65 # -g: make it global, this is required when used with antigen.
66 typeset -g -A _autoenv_stack_entered_mtime
67
68 # Add an entry to the stack, and remember its mtime.
69 _autoenv_stack_entered_add() {
70   local env_file=$1
71
72   # Remove any existing entry.
73   _autoenv_stack_entered_remove $env_file
74
75   # Append it to the stack, and remember its mtime.
76   _autoenv_debug "[stack] adding: $env_file" 2
77   _autoenv_stack_entered+=($env_file)
78   _autoenv_stack_entered_mtime[$env_file]=$(_autoenv_get_file_mtime $env_file)
79 }
80
81 # zstat_mime helper, conditionally defined.
82 # Load zstat module, but only its builtin `zstat`.
83 if ! zmodload -F zsh/stat b:zstat 2>/dev/null; then
84   # If the module is not available, define a wrapper around `stat`, and use its
85   # terse output instead of format, which is not supported by busybox.
86   # Assume '+mtime' as $1.
87   _autoenv_get_file_mtime() {
88     # setopt localoptions pipefail
89     local stat
90     stat=$(stat -t $1 2>/dev/null)
91     if [[ -n $stat ]]; then
92       echo ${${(s: :)stat}[13]}
93     else
94       echo 0
95     fi
96   }
97 else
98   _autoenv_get_file_mtime() {
99     zstat +mtime $1 2>/dev/null || echo 0
100   }
101 fi
102
103 # Remove an entry from the stack.
104 _autoenv_stack_entered_remove() {
105   local env_file=$1
106   _autoenv_debug "[stack] removing: $env_file" 2
107   _autoenv_stack_entered[$_autoenv_stack_entered[(i)$env_file]]=()
108   _autoenv_stack_entered_mtime[$env_file]=
109 }
110
111 # Is the given entry already in the stack?
112 # This checks for the env_file ($1) as-is and with symlinks resolved.
113 _autoenv_stack_entered_contains() {
114   local env_file=$1
115   local f i
116   if (( ${+_autoenv_stack_entered[(r)${env_file}]} )); then
117     # Entry is in stack.
118     f=$env_file
119   else
120     for i in $_autoenv_stack_entered; do
121       if [[ ${i:A} == ${env_file:A} ]]; then
122         # Entry is in stack (compared with resolved symlinks).
123         f=$i
124         break
125       fi
126     done
127   fi
128   if [[ -n $f ]]; then
129     if [[ $_autoenv_stack_entered_mtime[$f] == $(_autoenv_get_file_mtime $f) ]]; then
130       # Entry has the expected mtime.
131       return
132     fi
133   fi
134   return 1
135 }
136 # }}}
137
138 # Internal function for debug output. {{{
139 _autoenv_debug() {
140   local level=${2:-1}
141   if (( AUTOENV_DEBUG < level )); then
142     return
143   fi
144   local msg="$1"  # Might trigger a bug in Zsh 5.0.5 with shwordsplit.
145   # Load zsh color support.
146   if [[ -z $color ]]; then
147     autoload colors
148     colors
149   fi
150   # Build $indent prefix.
151   local indent=
152   if [[ $_autoenv_debug_indent -gt 0 ]]; then
153     for i in {1..${_autoenv_debug_indent}}; do
154       indent="  $indent"
155     done
156   fi
157
158   # Split $msg by \n (not newline).
159   lines=(${(ps:\\n:)msg})
160   for line in $lines; do
161     echo -n "${fg_bold[blue]}[autoenv]${fg_no_bold[default]} " >&2
162     echo ${indent}${line} >&2
163   done
164 }
165 # }}}
166
167
168 # Generate hash pair for a given file ($1) and version ($2).
169 # A fixed hash value can be given as 3rd arg, but is used with tests only.
170 # The format is ":$file:$hash:$version".
171 _autoenv_hash_pair() {
172   local env_file=${1:A}
173   local cksum_version=${2:-2}
174   local env_cksum=${3:-}
175   if [[ -z $env_cksum ]]; then
176     if ! [[ -e $env_file ]]; then
177       echo "Missing file argument for _autoenv_hash_pair!" >&2
178       return 1
179     fi
180     if [ $cksum_version = 2 ]; then
181       # Get the output from `cksum` and join the first two words with a dot.
182       env_cksum=${(j:.:)${:-$(cksum "$env_file")}[1,2]}
183     elif [ $cksum_version = 1 ]; then
184       env_cksum=$(shasum $env_file | cut -d' ' -f1)
185     else
186       echo "Invalid version argument (${cksum_version}) for _autoenv_hash_pair!" >&2
187       return 1
188     fi
189   fi
190   echo ":${env_file}:${env_cksum}:${cksum_version}"
191 }
192
193
194 # Checks for the existence of a hash signature in the auth file
195 _autoenv_authorized_pair() {
196   local pair=$1
197   test -f $AUTOENV_AUTH_FILE \
198     && \grep -qF $pair $AUTOENV_AUTH_FILE
199 }
200
201
202 _autoenv_authorized_env_file() {
203   local env_file=$1
204   local pair
205   pair=$(_autoenv_hash_pair $env_file)
206   _autoenv_debug "v2 pair: ${pair}"
207   if ! _autoenv_authorized_pair $pair; then
208     # Fallback for v1 (SHA-1) pairs
209     pair=$(_autoenv_hash_pair $env_file 1)
210     _autoenv_debug "v1 pair: ${pair}"
211     if _autoenv_authorized_pair $pair; then
212       # Upgrade v1 entries to v2
213       _autoenv_authorize $env_file
214     else
215       return 1
216     fi
217   fi
218 }
219
220 _autoenv_authorize() {
221   local env_file=${1:A}
222   _autoenv_deauthorize $env_file
223   [[ -d ${AUTOENV_AUTH_FILE:h} ]] || mkdir -p ${AUTOENV_AUTH_FILE:h}
224   _autoenv_hash_pair $env_file >>| $AUTOENV_AUTH_FILE
225 }
226
227 # Deauthorize a given filename, by removing it from the auth file.
228 # This uses `test -s` to only handle non-empty files.
229 _autoenv_deauthorize() {
230   local env_file=${1:A}
231   if [[ -s $AUTOENV_AUTH_FILE ]]; then
232     \grep -vF :${env_file}: $AUTOENV_AUTH_FILE >| $AUTOENV_AUTH_FILE.tmp
233     \mv $AUTOENV_AUTH_FILE.tmp $AUTOENV_AUTH_FILE
234   fi
235 }
236
237 # This function can be mocked in tests
238 _autoenv_ask_for_yes() {
239   local answer
240
241   # Handle/catch Ctrl-C and return, instead of letting it potentially abort the
242   # shell setup process.
243   setopt localtraps
244   trap 'return 1' INT
245
246   read answer
247   if [[ $answer == "yes" ]]; then
248     return 0
249   else
250     return 1
251   fi
252 }
253
254 # Args: 1: absolute path to env file (resolved symlinks).
255 _autoenv_check_authorized_env_file() {
256   if ! [[ -f $1 ]]; then
257     return 1
258   fi
259   if ! _autoenv_authorized_env_file $1; then
260     echo "Attempting to load unauthorized env file!" >&2
261     command ls -l $1 >&2
262     echo >&2
263     echo "**********************************************" >&2
264     echo >&2
265     command cat $1 >&2
266     echo >&2
267     echo "**********************************************" >&2
268     echo >&2
269     echo -n "Would you like to authorize it? (type 'yes') " >&2
270     # echo "Would you like to authorize it?"
271     # echo "('yes' to allow, 'no' to not being asked again; otherwise ignore it for the shell) "
272
273     if ! _autoenv_ask_for_yes; then
274       return 1
275     fi
276
277     _autoenv_authorize $1
278   fi
279   return 0
280 }
281
282 _autoenv_source() {
283   # Public API for the .autoenv.zsh script.
284   local autoenv_env_file=$1
285   local autoenv_event=$2
286   local autoenv_from_dir=$OLDPWD
287   local autoenv_to_dir=$PWD
288
289   # Source varstash library once.
290   # XXX: pollutes environment with e.g. `stash`, and `autostash` will cause
291   # an overwritten `stash` function to be called!
292   if ! (( $+functions[autostash] )); then
293     if \grep -qE '\b(autostash|autounstash|stash|unstash)\b' $autoenv_env_file; then
294       source ${${funcsourcetrace[1]%:*}:h}/lib/varstash
295     fi
296   fi
297
298   # Source the env file.
299   _autoenv_debug "== SOURCE: ${bold_color:-}$autoenv_env_file${reset_color:-}\n      PWD: $PWD"
300   (( ++_autoenv_debug_indent ))
301
302   local restore_xtrace
303   if [[ $AUTOENV_DEBUG -gt 2 && ! -o xtrace ]]; then
304     restore_xtrace=1
305     setopt localoptions xtrace
306   fi
307
308   varstash_dir=${autoenv_env_file:h} source $autoenv_env_file
309   if (( restore_xtrace )); then
310     setopt noxtrace
311   fi
312   (( --_autoenv_debug_indent ))
313   _autoenv_debug "== END SOURCE =="
314
315   if [[ $autoenv_event == enter ]]; then
316     _autoenv_stack_entered_add $autoenv_env_file
317   fi
318 }
319
320 _autoenv_get_file_upwards() {
321   local look_from=${1:-$PWD}
322   local look_for=${2:-$AUTOENV_FILE_ENTER}
323   local look_until=${${3:-/}:A}
324
325   # Manually look in parent dirs. An extended Zsh glob should use Y1 for
326   # performance reasons, which is only available in zsh-5.0.5-146-g9381bb6.
327   local last
328   local parent_dir="$look_from/.."
329   local abs_parent_dir
330   while true; do
331     abs_parent_dir=${parent_dir:A}
332     if [[ $abs_parent_dir == $last ]]; then
333       break
334     fi
335     local parent_file="${parent_dir}/${look_for}"
336
337     if [[ -f $parent_file ]]; then
338       if [[ ${parent_file[1,2]} == './' ]]; then
339         echo ${parent_file#./}
340       else
341         echo ${parent_file:a}
342       fi
343       break
344     fi
345
346     if [[ $abs_parent_dir == $look_until ]]; then
347       break
348     fi
349     last=$parent_dir
350     parent_dir="${parent_dir}/.."
351   done
352 }
353
354 autoenv-edit() {
355   local env_file
356   local -a files
357   local -A check
358   check[enter]=$AUTOENV_FILE_ENTER
359   if [[ "$AUTOENV_FILE_ENTER" != "$AUTOENV_FILE_LEAVE" ]]; then
360     check[leave]=$AUTOENV_FILE_LEAVE
361   fi
362   local f t
363   for t f in ${(kv)check}; do
364     env_file="$f"
365     if ! [[ -f $env_file ]]; then
366       env_file=$(_autoenv_get_file_upwards . $f)
367       if [[ -z $env_file ]]; then
368         echo "No $f file found ($t)." >&2
369         continue
370       fi
371       if ! [[ $AUTOENV_LOOK_UPWARDS == 1 ]]; then
372         echo "Note: found $env_file, but AUTOENV_LOOK_UPWARDS is disabled."
373       fi
374     fi
375     files+=($env_file)
376   done
377   if [[ -z "$files" ]]; then
378     return 1
379   fi
380   echo "Editing $files.."
381   local editor
382   editor="${${AUTOENV_EDITOR:-$EDITOR}:-vim}"
383   eval $editor "$files"
384 }
385
386 _autoenv_chpwd_handler() {
387   _autoenv_debug "Calling chpwd handler: PWD=$PWD"
388
389   if (( $AUTOENV_DISABLED )); then
390     _autoenv_debug "Disabled (AUTOENV_DISABLED)."
391     return
392   fi
393
394   local env_file="$PWD/$AUTOENV_FILE_ENTER"
395   _autoenv_debug "Looking for env_file: $env_file"
396
397   # Handle leave event for previously sourced env files.
398   if [[ $AUTOENV_HANDLE_LEAVE == 1 ]] && (( $#_autoenv_stack_entered )); then
399     local prev_file prev_dir
400     for prev_file in ${_autoenv_stack_entered}; do
401       prev_dir=${prev_file:h}
402       if ! [[ ${PWD}/ == ${prev_dir}/* ]]; then
403         local env_file_leave=$prev_dir/$AUTOENV_FILE_LEAVE
404         if _autoenv_check_authorized_env_file $env_file_leave; then
405           varstash_dir=$prev_dir _autoenv_source $env_file_leave leave $prev_dir
406         fi
407
408         # Unstash any autostashed stuff.
409         if (( $+functions[autostash] )); then
410           varstash_dir=$prev_dir autounstash
411         fi
412
413         _autoenv_stack_entered_remove $prev_file
414       fi
415     done
416   fi
417
418   if ! [[ -f $env_file ]] && [[ $AUTOENV_LOOK_UPWARDS == 1 ]]; then
419     env_file=$(_autoenv_get_file_upwards $PWD)
420     if [[ -z $env_file ]]; then
421       _autoenv_debug "No env_file found when looking upwards"
422       return
423     fi
424     _autoenv_debug "Found env_file: $env_file"
425   fi
426
427   # Load the env file only once: check if $env_file is in the stack of entered
428   # directories.
429   if _autoenv_stack_entered_contains $env_file; then
430     _autoenv_debug "Already in stack: $env_file"
431     return
432   fi
433
434   if ! _autoenv_check_authorized_env_file $env_file; then
435     return
436   fi
437
438   # Source the enter env file.
439   _autoenv_debug "Sourcing from chpwd handler: $env_file"
440   _autoenv_source $env_file enter
441
442   (( ++_autoenv_debug_indent ))
443 }
444 # }}}
445
446 autoload -U add-zsh-hook
447 add-zsh-hook chpwd _autoenv_chpwd_handler
448
449 # Look in current directory already.
450 _autoenv_chpwd_handler